=== modified file 'drizzled/Makefile.am'
--- drizzled/Makefile.am	2009-09-22 17:56:50 +0000
+++ drizzled/Makefile.am	2009-09-22 19:11:16 +0000
@@ -296,6 +296,8 @@
 		set_var.h \
 		show.h \
 		slot/authentication.h \
+		slot/command_replicator.h \
+		slot/command_applier.h \
 		slot/error_message.h \
 		slot/function.h \
 		slot/info_schema.h \
@@ -616,6 +618,8 @@
 		set_var.cc \
 		show.cc \
 		slot/authentication.cc \
+		slot/command_replicator.cc \
+		slot/command_applier.cc \
 		slot/error_message.cc \
 		slot/function.cc \
 		slot/info_schema.cc \

=== modified file 'drizzled/db.cc'
--- drizzled/db.cc	2009-08-19 23:35:29 +0000
+++ drizzled/db.cc	2009-09-22 19:11:16 +0000
@@ -38,8 +38,6 @@
 
 using namespace drizzled;
 
-extern drizzled::ReplicationServices replication_services;
-
 #define MY_DB_OPT_FILE "db.opt"
 #define MAX_DROP_TABLE_Q_LEN      1024
 
@@ -190,6 +188,7 @@
 
 bool mysql_create_db(Session *session, const char *db, HA_CREATE_INFO *create_info)
 {
+  ReplicationServices &replication_services= ReplicationServices::singleton();
   char	 path[FN_REFLEN+16];
   long result= 1;
   int error_erno;
@@ -277,6 +276,7 @@
 
 bool mysql_alter_db(Session *session, const char *db, HA_CREATE_INFO *create_info)
 {
+  ReplicationServices &replication_services= ReplicationServices::singleton();
   long result=1;
   int error= 0;
   char	 path[FN_REFLEN+16];
@@ -420,6 +420,7 @@
       query= session->query;
       query_length= session->query_length;
     }
+    ReplicationServices &replication_services= ReplicationServices::singleton();
     replication_services.rawStatement(session, session->getQueryString(), session->getQueryLength());
     session->clear_error();
     session->server_status|= SERVER_STATUS_DB_DROPPED;
@@ -438,6 +439,7 @@
     query_end= query + MAX_DROP_TABLE_Q_LEN;
     db_len= strlen(db);
 
+    ReplicationServices &replication_services= ReplicationServices::singleton();
     for (tbl= dropped_tables; tbl; tbl= tbl->next_local)
     {
       uint32_t tbl_name_len;

=== modified file 'drizzled/handler.cc'
--- drizzled/handler.cc	2009-08-23 01:10:19 +0000
+++ drizzled/handler.cc	2009-09-22 19:11:16 +0000
@@ -43,8 +43,6 @@
 using namespace std;
 using namespace drizzled;
 
-extern drizzled::ReplicationServices replication_services;
-
 KEY_CREATE_INFO default_key_create_info= { HA_KEY_ALG_UNDEF, 0, {NULL,0} };
 
 /* number of entries in storage_engines[] */
@@ -2653,6 +2651,7 @@
                            const unsigned char *before_record,
                            const unsigned char *after_record)
 {
+  ReplicationServices &replication_services= ReplicationServices::singleton();
   Session *const session= table->in_use;
 
   switch (session->lex->sql_command)

=== modified file 'drizzled/plugin/registry.cc'
--- drizzled/plugin/registry.cc	2009-09-22 17:56:50 +0000
+++ drizzled/plugin/registry.cc	2009-09-22 19:11:16 +0000
@@ -23,7 +23,6 @@
 #include "drizzled/plugin.h"
 #include "drizzled/show.h"
 #include "drizzled/handler.h"
-#include "drizzled/replication_services.h"
 
 #include <string>
 #include <vector>
@@ -83,29 +82,9 @@
   add_storage_engine(engine);
 }
 
-void plugin::Registry::add(plugin::CommandReplicator *replicator)
-{
-  add_replicator(replicator);
-}
-
-void plugin::Registry::add(plugin::CommandApplier *applier)
-{
-  add_applier(applier);
-}
-
 void plugin::Registry::remove(StorageEngine *engine)
 {
   remove_storage_engine(engine);
 }
 
-void plugin::Registry::remove(plugin::CommandReplicator *replicator)
-{
-  remove_replicator(replicator);
-}
-
-void plugin::Registry::remove(plugin::CommandApplier *applier)
-{
-  remove_applier(applier);
-}
-
 } /* namespace drizzled */

=== modified file 'drizzled/plugin/registry.h'
--- drizzled/plugin/registry.h	2009-09-22 17:56:50 +0000
+++ drizzled/plugin/registry.h	2009-09-22 19:11:16 +0000
@@ -20,6 +20,10 @@
 #ifndef DRIZZLED_PLUGIN_REGISTRY_H
 #define DRIZZLED_PLUGIN_REGISTRY_H
 
+#include <string>
+#include <vector>
+#include <map>
+
 #include "drizzled/slot/authentication.h"
 #include "drizzled/slot/scheduler.h"
 #include "drizzled/slot/function.h"
@@ -28,10 +32,8 @@
 #include "drizzled/slot/logging.h"
 #include "drizzled/slot/error_message.h"
 #include "drizzled/slot/info_schema.h"
-
-#include <string>
-#include <vector>
-#include <map>
+#include "drizzled/slot/command_replicator.h"
+#include "drizzled/slot/command_applier.h"
 
 class StorageEngine;
 class Authentication;
@@ -40,8 +42,6 @@
 {
 namespace plugin
 {
-class CommandReplicator;
-class CommandApplier;
 class Handle;
 
 class Registry
@@ -67,13 +67,11 @@
   std::vector<Handle *> get_list(bool active);
 
   void add(StorageEngine *engine);
-  void add(::drizzled::plugin::CommandReplicator *replicator);
-  void add(::drizzled::plugin::CommandApplier *applier);
 
   void remove(StorageEngine *engine);
-  void remove(::drizzled::plugin::CommandReplicator *replicator);
-  void remove(::drizzled::plugin::CommandApplier *applier);
 
+  ::drizzled::slot::CommandReplicator command_replicator;
+  ::drizzled::slot::CommandApplier command_applier;
   ::drizzled::slot::ErrorMessage error_message;
   ::drizzled::slot::Authentication authentication;
   ::drizzled::slot::QueryCache query_cache;

=== modified file 'drizzled/replication_services.cc'
--- drizzled/replication_services.cc	2009-09-16 17:10:18 +0000
+++ drizzled/replication_services.cc	2009-09-22 19:11:16 +0000
@@ -56,28 +56,6 @@
 using namespace std;
 using namespace drizzled;
 
-ReplicationServices replication_services;
-
-void add_replicator(plugin::CommandReplicator *replicator)
-{
-  replication_services.attachReplicator(replicator);
-}
-
-void remove_replicator(plugin::CommandReplicator *replicator)
-{
-  replication_services.detachReplicator(replicator);
-}
-
-void add_applier(plugin::CommandApplier *applier)
-{
-  replication_services.attachApplier(applier);
-}
-
-void remove_applier(plugin::CommandApplier *applier)
-{
-  replication_services.detachApplier(applier);
-}
-
 ReplicationServices::ReplicationServices()
 {
   is_active= false;

=== modified file 'drizzled/replication_services.h'
--- drizzled/replication_services.h	2009-07-29 09:19:15 +0000
+++ drizzled/replication_services.h	2009-09-22 19:11:16 +0000
@@ -42,21 +42,13 @@
   {
     class Command;
   }
-}
-
-void add_replicator(drizzled::plugin::CommandReplicator *replicator);
-void remove_replicator(drizzled::plugin::CommandReplicator *replicator);
-
-void add_applier(drizzled::plugin::CommandApplier *applier);
-void remove_applier(drizzled::plugin::CommandApplier *applier);
+
 
 /**
  * This is a class which manages transforming internal 
  * transactional events into GPB messages and sending those
  * events out through registered replicators and appliers.
  */
-namespace drizzled
-{
 class ReplicationServices
 {
 public:
@@ -103,6 +95,17 @@
    * Constructor
    */
   ReplicationServices();
+
+  /**
+   * Singleton method
+   * Returns the singleton instance of ReplicationServices
+   */
+  static inline ReplicationServices &singleton()
+  {
+    static ReplicationServices replication_services;
+    return replication_services;
+  }
+
   /**
    * Returns whether the ReplicationServices object
    * is active.  In other words, does it have both

=== added file 'drizzled/slot/command_applier.cc'
--- drizzled/slot/command_applier.cc	1970-01-01 00:00:00 +0000
+++ drizzled/slot/command_applier.cc	2009-09-22 19:11:16 +0000
@@ -0,0 +1,39 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2009 Sun Microsystems
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#include "drizzled/global.h"
+
+#include "drizzled/replication_services.h"
+#include "drizzled/slot/command_applier.h"
+
+using namespace std;
+using namespace drizzled;
+
+void slot::CommandApplier::add(plugin::CommandApplier *applier)
+{
+  ReplicationServices &replication_services= ReplicationServices::singleton();
+  replication_services.attachApplier(applier);
+}
+
+void slot::CommandApplier::remove(plugin::CommandApplier *applier)
+{
+  ReplicationServices &replication_services= ReplicationServices::singleton();
+  replication_services.detachApplier(applier);
+}
+

=== added file 'drizzled/slot/command_applier.h'
--- drizzled/slot/command_applier.h	1970-01-01 00:00:00 +0000
+++ drizzled/slot/command_applier.h	2009-09-22 19:11:16 +0000
@@ -0,0 +1,46 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2009 Sun Microsystems
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifndef DRIZZLED_SLOT_COMMAND_APPLIER_H
+#define DRIZZLED_SLOT_COMMAND_APPLIER_H
+
+namespace drizzled
+{
+namespace plugin
+{
+  class CommandApplier;
+}
+  
+namespace slot
+{
+
+class CommandApplier
+{
+public:
+  void add(plugin::CommandApplier *applier);
+
+  void remove(plugin::CommandApplier *applier);
+
+};
+
+
+} /* end namespace slot */
+} /* end namespace drizzled */
+
+#endif /* DRIZZLED_SLOT_COMMAND_APPLIER_H */

=== added file 'drizzled/slot/command_replicator.cc'
--- drizzled/slot/command_replicator.cc	1970-01-01 00:00:00 +0000
+++ drizzled/slot/command_replicator.cc	2009-09-22 19:11:16 +0000
@@ -0,0 +1,40 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2009 Sun Microsystems
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#include "drizzled/global.h"
+
+#include "drizzled/replication_services.h"
+#include "drizzled/slot/command_replicator.h"
+
+using namespace std;
+using namespace drizzled;
+
+void slot::CommandReplicator::add(plugin::CommandReplicator *replicator)
+{
+  ReplicationServices &replication_services= ReplicationServices::singleton();
+  replication_services.attachReplicator(replicator);
+}
+
+void slot::CommandReplicator::remove(plugin::CommandReplicator *replicator)
+{
+  ReplicationServices &replication_services= ReplicationServices::singleton();
+  replication_services.detachReplicator(replicator);
+}
+
+

=== added file 'drizzled/slot/command_replicator.h'
--- drizzled/slot/command_replicator.h	1970-01-01 00:00:00 +0000
+++ drizzled/slot/command_replicator.h	2009-09-22 19:11:16 +0000
@@ -0,0 +1,47 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2009 Sun Microsystems
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifndef DRIZZLED_SLOT_COMMAND_REPLICATOR_H
+#define DRIZZLED_SLOT_COMMAND_REPLICATOR_H
+
+
+namespace drizzled
+{
+namespace plugin
+{
+  class CommandReplicator;
+}
+  
+namespace slot
+{
+
+class CommandReplicator
+{
+public:
+  void add(plugin::CommandReplicator *replicator);
+
+  void remove(plugin::CommandReplicator *replicator);
+
+};
+
+
+} /* end namespace slot */
+} /* end namespace drizzled */
+
+#endif /* DRIZZLED_SLOT_COMMAND_REPLICATOR_H */

=== modified file 'drizzled/sql_base.cc'
--- drizzled/sql_base.cc	2009-08-20 20:29:18 +0000
+++ drizzled/sql_base.cc	2009-09-22 19:11:16 +0000
@@ -50,8 +50,6 @@
 using namespace std;
 using namespace drizzled;
 
-extern drizzled::ReplicationServices replication_services;
-
 bool drizzle_rm_tmp_tables(slot::Listen &listen_handler);
 
 /**
@@ -2045,6 +2043,7 @@
   */
   if (unlikely(entry->file->implicit_emptied))
   {
+    ReplicationServices &replication_services= ReplicationServices::singleton();
     entry->file->implicit_emptied= 0;
     {
       char *query, *end;

=== modified file 'drizzled/sql_table.cc'
--- drizzled/sql_table.cc	2009-09-16 21:55:09 +0000
+++ drizzled/sql_table.cc	2009-09-22 19:11:16 +0000
@@ -40,7 +40,6 @@
 
 using namespace std;
 using namespace drizzled;
-extern drizzled::ReplicationServices replication_services;
 
 static const char hexchars[]= "0123456789abcdef";
 bool is_primary_key(KEY *key_info)
@@ -329,6 +328,7 @@
 void write_bin_log(Session *session, bool,
                    char const *query, size_t query_length)
 {
+  ReplicationServices &replication_services= ReplicationServices::singleton();
   replication_services.rawStatement(session, query, query_length);
 }
 

=== modified file 'plugin/command_log/command_log.cc'
--- plugin/command_log/command_log.cc	2009-09-16 17:10:18 +0000
+++ plugin/command_log/command_log.cc	2009-09-22 19:11:16 +0000
@@ -66,16 +66,17 @@
 
 #include "command_log.h"
 
+#include <unistd.h>
+#include <zlib.h>
+
+#include <vector>
+#include <string>
+
 #include <drizzled/session.h>
 #include <drizzled/set_var.h>
 #include <drizzled/gettext.h>
 #include <drizzled/message/replication.pb.h>
 
-#include <vector>
-#include <string>
-#include <unistd.h>
-#include <zlib.h>
-
 using namespace std;
 using namespace drizzled;
 
@@ -355,7 +356,7 @@
   {
     command_log= new CommandLog(sysvar_command_log_file, 
                                 sysvar_command_log_checksum_enabled);
-    registry.add(command_log);
+    registry.command_applier.add(command_log);
   }
   return 0;
 }
@@ -364,7 +365,7 @@
 {
   if (command_log)
   {
-    registry.remove(command_log);
+    registry.command_applier.remove(command_log);
     delete command_log;
   }
   return 0;

=== modified file 'plugin/default_replicator/default_replicator.cc'
--- plugin/default_replicator/default_replicator.cc	2009-09-16 17:10:18 +0000
+++ plugin/default_replicator/default_replicator.cc	2009-09-22 19:11:16 +0000
@@ -76,7 +76,7 @@
 static int init(drizzled::plugin::Registry &registry)
 {
   default_replicator= new DefaultReplicator();
-  registry.add(default_replicator);
+  registry.command_replicator.add(default_replicator);
   return 0;
 }
 
@@ -84,7 +84,7 @@
 {
   if (default_replicator)
   {
-    registry.remove(default_replicator);
+    registry.command_replicator.remove(default_replicator);
     delete default_replicator;
   }
   return 0;

=== modified file 'plugin/filtered_replicator/filtered_replicator.cc'
--- plugin/filtered_replicator/filtered_replicator.cc	2009-09-16 20:04:11 +0000
+++ plugin/filtered_replicator/filtered_replicator.cc	2009-09-22 19:11:16 +0000
@@ -399,7 +399,7 @@
     {
       return 1;
     }
-    registry.add(filtered_replicator);
+    registry.command_replicator.add(filtered_replicator);
   }
   return 0;
 }
@@ -408,7 +408,7 @@
 {
   if (filtered_replicator)
   {
-    registry.remove(filtered_replicator);
+    registry.command_replicator.remove(filtered_replicator);
     delete filtered_replicator;
   }
   return 0;

